import scipy as sci
from scipy import linalg
# D. Ryckelynck 2018

def k_swim(V,kmax):
    kmax = max(0,kmax-1)
    r = V[:,0]
    i = sci.argmax(abs(r))
    P=[i]
    for k in range(kmax):
      r[i]=0.
      i = sci.argmax(abs(r))
      P = sci.append(P,i)
    for l in sci.arange(1,sci.shape(V)[1],1):
        G = sci.dot( sci.transpose( V[P,:l] ), V[P,:l] )
        F = sci.dot( sci.transpose( V[P,:l] ), V[P,l] )
        gamma =    linalg.solve( G , F )
        r = V[:,l] - sci.dot(V[:,:l],gamma)
        i = sci.argmax(abs(r))
        P = sci.append(P,i)
        for k in range(kmax):
           r[i]=0.
           i = sci.argmax(abs(r))
           P = sci.append(P,i)
    return P 
